import alrosine.ean.upc.UpcQueryService;
import alrosine.ean.upc.UpcResponse;
import alrosine.ean.upc.impl.UpcQueryServiceFactory;

public class EanDataRetrievalTest {

	public static final String COKE_UPC_CODE = "049000000443";

	public static void main(String args[]) {

		UpcQueryService queryService = UpcQueryServiceFactory.getUpcQueryService();
		UpcResponse response;
		if (args.length == 0) {
			System.out.println("No arguments provided. Defaulting to Coke UPC (" + COKE_UPC_CODE + ").");
			response = queryService.getUpcResponse(COKE_UPC_CODE);
			System.out.println("UPC: " + response.getUpc() + " / Product Name: " + response.getProduct().getName());
		} else {
			System.out.println(args.length + " arguments provided...");
			for(int idx=0;idx<args.length;idx++) {
				String upc = args[1];
				if ((upc == null) || (upc.trim().length() == 0)) {
					System.out.println("Argument " + idx + " is null or an empty string. Ignored.");
				} else {
					try {
						response = queryService.getUpcResponse(upc.trim());
						if (response != null) {
							System.out.println("Argument " + idx + " UPC: " + response.getUpc() + " / Product Name: " + response.getProduct().getName());
						}
					} catch(Exception e) {
						System.out.println("Argument " + idx + " (" + upc.trim() + ") caused an exception when retrieval attempted...");
						e.printStackTrace();
					}
				}
			}
		}


	}

}