package alrosine.ean.upc.impl;

import alrosine.ean.upc.UpcCompany;

/**
 * Default implementation of the UpcCompany interface
 */
public class UpcCompanyImpl implements UpcCompany {

	private String name;
	private String logoUrl;
	private boolean logoImageRetrieved;
	private byte[] logoImage;
	private String url;
	private String address;
	private String telephone;
	private boolean locked;

	@Override
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Override
	public String getLogoUrl() {
		return logoUrl;
	}

	public void setLogoUrl(String logoUrl) {
		this.logoUrl = logoUrl;
	}

	@Override
	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	@Override
	public byte[] getLogoImage() {
		if (!this.logoImageRetrieved) {
			this.setLogoImage(UpcUtility.retrieveImage(this.getLogoUrl()));
		}
		return logoImage;
	}

	public void setLogoImage(byte[] logoImage) {
		this.logoImage = logoImage;
		this.logoImageRetrieved = true;
	}

	@Override
	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	@Override
	public String getTelephone() {
		return telephone;
	}

	public void setTelephone(String telephone) {
		this.telephone = telephone;
	}

	@Override
	public boolean isLocked() {
		return locked;
	}

	public void setLocked(boolean locked) {
		this.locked = locked;
	}
}
