package alrosine.ean.upc.impl;

import alrosine.ean.upc.UpcProduct;

import java.util.Date;

/**
 * Default implementation of the UpcProduct interface
 */
public class UpcProductImpl implements UpcProduct {

	private Date lastModified;
	private String ean13;
	private String upcA;
	private String upcE;
	private String isbn;
	private String name;
	private String description;
	private String categoryCode;
	private String categoryName;
	private String companyUrl;
	private String productImageUrl;
	private boolean productImageRetrieved;
	private byte[] productImage;
	private boolean longDescription;
	private String barcodeUrl;
	private boolean barcodeRetrieved;
	private byte[] barcodeImage;
	private boolean locked;

	@Override
	public Date getLastModified() {
		return lastModified;
	}

	public void setLastModified(Date lastModified) {
		this.lastModified = lastModified;
	}

	@Override
	public String getEan13() {
		return ean13;
	}

	public void setEan13(String ean13) {
		this.ean13 = ean13;
	}

	@Override
	public String getUpcA() {
		return upcA;
	}

	public void setUpcA(String upcA) {
		this.upcA = upcA;
	}

	@Override
	public String getUpcE() {
		return upcE;
	}

	public void setUpcE(String upcE) {
		this.upcE = upcE;
	}

	@Override
	public String getIsbn() {
		return isbn;
	}

	public void setIsbn(String isbn) {
		this.isbn = isbn;
	}

	@Override
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Override
	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	@Override
	public String getCategoryCode() {
		return categoryCode;
	}

	public void setCategoryCode(String categoryCode) {
		this.categoryCode = categoryCode;
	}

	@Override
	public String getCategoryName() {
		return categoryName;
	}

	public void setCategoryName(String categoryName) {
		this.categoryName = categoryName;
	}

	@Override
	public String getCompanyUrl() {
		return companyUrl;
	}

	public void setCompanyUrl(String companyUrl) {
		this.companyUrl = companyUrl;
	}

	@Override
	public String getProductImageUrl() {
		return productImageUrl;
	}

	public void setProductImageUrl(String productImageUrl) {
		this.productImageUrl = productImageUrl;
	}

	@Override
	public byte[] getProductImage() {
		if (!this.productImageRetrieved) {
			this.setProductImage(UpcUtility.retrieveImage(this.getProductImageUrl()));
		}
		return productImage;
	}

	public void setProductImage(byte[] productImage) {
		this.productImage = productImage;
		this.productImageRetrieved = true;
	}

	@Override
	public boolean isLongDescription() {
		return longDescription;
	}

	public void setLongDescription(boolean longDescription) {
		this.longDescription = longDescription;
	}

	@Override
	public String getBarcodeUrl() {
		return barcodeUrl;
	}

	public void setBarcodeUrl(String barcodeUrl) {
		this.barcodeUrl = barcodeUrl;
	}

	@Override
	public byte[] getBarcodeImage() {
		if (!this.barcodeRetrieved) {
			this.setBarcodeImage(UpcUtility.retrieveImage(this.getBarcodeUrl()));
		}
		return barcodeImage;
	}

	public void setBarcodeImage(byte[] barcodeImage) {
		this.barcodeImage = barcodeImage;
		this.barcodeRetrieved = true;
	}

	@Override
	public boolean isLocked() {
		return locked;
	}

	public void setLocked(boolean locked) {
		this.locked = locked;
	}
}
