package alrosine.ean.upc.impl;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * Simple utility class to perform common functionality.
 */
class UpcUtility {

	private UpcUtility() {
	}

	protected static InputStream getUrl(String desiredUrl) {
		try {
			URL url = new URL(desiredUrl);
			return url.openStream();
		} catch (MalformedURLException e) {
			e.printStackTrace();
			throw new RuntimeException("Attempt to retrieve URL failed. (" + desiredUrl + ")", e);
		} catch (IOException e) {
			e.printStackTrace();
			throw new RuntimeException("Attempt to retrieve URL failed. (" + desiredUrl + ")", e);
		}
	}

	protected static byte[] retrieveImage(String url) {
		byte[] imageBytes = null;
		if ((url != null) && (url.trim().length() > 0)) {
			InputStream dataStream = UpcUtility.getUrl(url);
			try {
				if ((dataStream != null) && (dataStream.available() > 0)) {
					imageBytes = new byte[dataStream.available()];
					dataStream.read(imageBytes);
				}
			} catch(IOException e) {
				e.printStackTrace();
				throw new RuntimeException("Attempt to retrieve image failed. (" + url + ")", e);
			}
		}
		return imageBytes;
	}

	protected static void writeFile(String fileName, byte[] bytes) {
		try {
			FileOutputStream out = new FileOutputStream(fileName);
			out.write(bytes);
			out.close();
		} catch(FileNotFoundException e) {
			e.printStackTrace();
			throw new RuntimeException("Unable to write image to file.", e);
		} catch(IOException e) {
			e.printStackTrace();
			throw new RuntimeException("Unable to write image to file.", e);
		}
	}


}
